package mailfotocamera;

import javax.microedition.lcdui.*;
import javax.microedition.media.control.*;
import javax.microedition.media.*;
import javax.microedition.io.Connector;
import javax.microedition.io.HttpConnection;
import java.io.*;

public class Fotocamera extends Canvas implements Runnable {

    public Display display;  // менеджер дисплея
    public Player mPlayer;
    public VideoControl mVideoControl;
    public static String SnapshotParam;
    public static String cameraParam;
    public static String mailMessage;
    public static String mailAddress;
    public static String URLMail =  "http://magdelphi.comyr.com";
    public static int dt_size = 1784;//размер куска для передачи
    public boolean running;
    public static securitylCamera rtime;
    int screenWidth = getWidth();
    int screenHeight = getHeight();
    public boolean procesbar;  //отображение процесбара
    public int dt_imag;       //размер файла картинки 
    private int messize;
    private Image fileicon = null;
    public static int countfile,  size_image,  i_proc;
    Image imclose = null;
    Image imback = null;
    Image imcamera = null;
    public static int action;
    private int fotocount = 0;
    public boolean initialized;
    String strStart = "Старт";
    boolean bolStart = false;

    public Fotocamera() {
        setFullScreenMode(true);//полноэкранный режим

        screenWidth = getWidth();
        screenHeight = getHeight();

        try {
            imclose = Image.createImage("/close.png");
            imback = Image.createImage("/back.png");
            imcamera = Image.createImage("/camera.png");
            fileicon = Image.createImage("/icons/fileemail.png");

        } catch (Exception e) {
        }

    }

    public void startcamera() {
        // setFullScreenMode(true);//полноэкранный режим
        try {
            cameraParam = getType();
            mPlayer = Manager.createPlayer(cameraParam);///"capture://video?width=480&height=640"

         //   System.out.println("парам камеры при создании  " + cameraParam);
            mPlayer.realize();
            mVideoControl = (VideoControl) mPlayer.getControl("VideoControl");
            mVideoControl.initDisplayMode(VideoControl.USE_GUI_PRIMITIVE, null);
            //  mVideoControl.setVisible(true);
            mPlayer.start();


        } catch (IOException ioe) {
        } catch (MediaException me) {
        }

    }

    private String getType() {
        String type = "capture://image";
        Player p;
        String stype[] = null;
        try {
            p = Manager.createPlayer(type);
        } catch (IOException ioe) {
            type = "capture://video";
        } catch (MediaException me) {

            type = "capture://video";
        } finally {
            p = null;
        }
        System.gc();
        return type;
    }

    public void start() {
        //   setFullScreenMode(true);//полноэкранный режим
        running = true;

        // создаем и запускаем поток
        Thread M_thread = new Thread(this);
        M_thread.setPriority(Thread.MAX_PRIORITY);
        M_thread.start();
        Thread.yield();

    }
//// метод run интерфейса Runnable  ********************************************
    public void run() {
        // бесконечный цикл
        while (running) {
            repaint();
            //обновление экрана

            try {
                Thread.sleep(200);
                Thread.yield();
            } catch (java.lang.InterruptedException zxz) {
            }
        }
    }

///**************************
    public void stop() {
        running = false;
        System.gc();
    }

//  /**
//   *Событие нажатия клавиш
//   *///
    protected void keyPressed(int key) {
        if (key != 0) {
            rtime.timework = 0;
        } //щелчок

        /*  if (procesbar) {
        return;//недействительны пока загрузка
        
        }*/
        switch (key) {

            case -6: {// -6 лев кл 

                rtime.destroyApp(true);
                break;
            }

            case -7: {// -7 правая 
                // rtime.commandAction(rtime.stopfotocamera, this);
                //   rtime.addScreen();

                break;
            }
            case -5: {// -5 центральная

                if (!bolStart) {
                    bolStart = true;
                    SendCapture();
                    strStart = "Стоп";
                } else {
                    bolStart = false;
                    strStart = "Старт";
                }

                break;
            }
            case 1: {
                break;
            }
            case 50: {

                break;
            }
        }
    }
//////**** перерисовка экрана **************************************************
    public void paint(Graphics g) {

        g.setColor(0);
        g.fillRect(0, 0, screenWidth, screenHeight);


        int i = 0;
        int x = screenWidth; // вычесляем область для перерисовки экрана

        int y = screenHeight;


        //--------- процессбар ----------------------------------
        try {
            if (procesbar) {//вкл. процесбар

                int barHeight = 0;//screenHeight - 20;

                dt_imag = size_image + messize;//размер файла картинки

                x -= 2;//уменьшаем ширину процессбара

                if (dt_imag == 0) {
                    dt_imag = x;
                }//если то ширина экрана

                y = dt_imag / 100;//1% - для вычисления значен. в процентах

                dt_imag /= x; //размер файла на 1 пиксель

                i = i_proc / dt_imag;// величина загрузки

                y = i_proc / y; // в процентах

                g.setFont(Font.getFont(Font.FACE_SYSTEM,
                        Font.STYLE_PLAIN, Font.SIZE_SMALL));//устанавливаем шрифт

                g.setColor(0xffffff);
                g.fillRect(0, barHeight, x, barHeight + 15);
                g.setColor(0x00ff00);
                g.drawRect(0, barHeight, x, barHeight + 15);
                g.fillRect(0, barHeight, i, barHeight + 15);

                g.setColor(0);
                g.drawString(String.valueOf(y) + "%", screenWidth / 2, 1, 0);//вывести текст

                if (y >= 100) {
                    procesbar = false;

                }//если 100% выключ процесс бар

            }

        } catch (java.lang.ArithmeticException c) {
        }
        //---------------------------------------------------------
        g.setColor(0xffffff);
        g.setFont(Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL));//устанавливаем шрифт

        g.drawString(strStart, screenWidth / 2 - 12, screenHeight - 37, 0);
        g.drawString("Выход", 5, screenHeight - 37, 0);
        g.drawString("Режим - " + rtime.resolution, 6, 50, 0);
        // g.drawString(" "+rtime.resolution, 6, 62, 0);
        g.drawString("Снято кадров - " + String.valueOf(fotocount), 6, 74, 0);

        //  g.drawImage(imback, screenWidth - 20, screenHeight - 17, 0);
        g.drawImage(imclose, 5, screenHeight - 17, 0);
        g.drawImage(imcamera, screenWidth / 2 - 8, screenHeight - 17, 0);
    //   g.drawImage(fileicon, screenWidth / 2 - 32, screenHeight / 2 - 32, 0);
    }

    //-------------поток для загрузки картинок ----------------------------------
    private class treadCap extends Thread {

        private treadCap() {
        }
        ///******сама съёмка фото и отправка  *****************
        public void capture() {
            while (bolStart) {
                if (initialized) {
                    initialized = false;
                    try {
                        action = 2;
                        byte[] raw = mVideoControl.getSnapshot(SnapshotParam);//"encoding=" + resolution SnapshotParam

                        i_proc = 0;
                        size_image = raw.length;
                        procesbar = true;
                        mVideoControl.setDisplayLocation(1, 20);
                        SendImag(raw, "ttt", 0);//передать

                        fotocount++;
                    } catch (MediaException me) {
                     //   System.out.println(me.toString());
                    }
                } else {

                    sleep(50);
                    dt_imag = size_image + messize;//размер файла картинки

                    if (i_proc >= dt_imag) {
                        sleep(rtime.timefoto * 1000);
                        initialized = true;
                    }
                }
            }
        }

        public synchronized void sleep(int duration) {
            try {
                //Thread.yield();
                Thread.sleep(duration);

            } catch (Exception e) {
            }


        }

        public synchronized void run() {

            initialized = true;
            capture();
        }
    }
    //************** сёмка в отдельном потоке  ***********************************
    public void SendCapture() {

        try {
            treadCap tt = new treadCap();//создаём поток для загрузки

            tt.setPriority(Thread.MIN_PRIORITY);
            tt.start();
            Thread.yield();

        } catch (java.lang.ArithmeticException axz) {
            return;
        }
    }

//-------------поток для загрузки картинок ----------------------------------
    private class treadIm extends Thread {

        private String im_messag;
        private byte[] treadimag;
        private int starthttp;

        private treadIm(byte[] imag, String messag, int midlstart) {
            treadimag = imag;
            im_messag = messag;
            starthttp = midlstart;

        }
//--------------------------------------------------------------------------------------
        private int sendLastImage(byte[] bufer) {
            int count = bufer.length;
        //    System.out.println(Integer.toString(count));
            int ncount = (count / dt_size);
            byte[] sendIm;
            for (int i = 0; i < ncount + 1; i++) {
                int dsize = dt_size;
                if (i < ncount) {
                    sendIm = new byte[dt_size];
                } else {
                    dsize = count - (ncount * dt_size);
                    sendIm = new byte[dsize];
                }
                for (int n = 0; n < dsize; n++) {
                    int offset = (i * dt_size) + n;
                    sendIm[n] = bufer[offset];
                }
                countfile = i;
                int repit = 0;
                boolean resout = true;
                while (resout) {
                    repit++;
                    if (repit > 3) {
                        return 1;
                    }
                    resout = sendBuffer(sendIm, URLMail + "/covertcam/" + rtime.fotodir + "/save.php?name=" + String.valueOf(i));
                }
                i_proc = i_proc + sendIm.length;

            }

            byte[] sendphp = toAnsi(mailMessage);
            messize = sendphp.length;

            sendBuffer(sendphp, URLMail + "/covertcam/" + rtime.fotodir + "/images/multiSave.php?tomail=" + mailAddress);
            i_proc = i_proc + sendphp.length;

            return 0;

        }
//-----------------------------------------------------------------------------------------------
        public byte[] toAnsi(String s) {
            byte[] array = s.getBytes();

            for (int i = 0, n = s.length(); i < n; i++) {
                char c;

                switch (c = s.charAt(i)) {
                    case 1025:
                        array[i] = -88;
                        break;
                    case 1105:
                        array[i] = -72;
                        break;
                    case 1168:
                        array[i] = -91;
                        break;
                    case 1028:
                        array[i] = -86;
                        break;
                    case 1031:
                        array[i] = -81;
                        break;
                    case 1030:
                        array[i] = -78;
                        break;
                    case 1110:
                        array[i] = -77;
                        break;
                    case 1169:
                        array[i] = -76;
                        break;
                    case 1108:
                        array[i] = -70;
                        break;
                    case 1111:
                        array[i] = -65;
                        break;
                    default:
                        if (c >= '\u0410' && c <= '\u044F') {
                            array[i] = (byte) ((c - 1040) + 192);
                        }
                }
            }
            return array;
        }

        public void sendStart() {
            byte[] bb = new byte[120];
            sendBuffer(bb, URLMail + "/covertcam/newImage.php?IdImage=" + rtime.fotodir);
        }

        public void sendStop() {
            byte[] bb = new byte[120];
            sendBuffer(bb, URLMail + "/covertcam/deleteDir.php?imagid=" + rtime.fotodir);
        }
//---------------------------------------------------------------------------------------
        public boolean sendBuffer(byte[] rawImag, String url) {
            HttpConnection connection = null;
            DataOutputStream dout = null;
            OutputStream os = new DataOutputStream(null);
            int reps = 0;
            try {
                connection = (HttpConnection) Connector.open(url);
                if (connection == null) {
                    return true;
                }
                connection.setRequestMethod(HttpConnection.POST);
                connection.setRequestProperty("User-Agent", "Profile/MIDP-2.0 Configuration/CLDC-1.0");
                connection.setRequestProperty("Content-Type", "application/octet-stream");
                connection.setRequestProperty("Content-Length", Integer.toString(rawImag.length));

                dout = new DataOutputStream(connection.openDataOutputStream());
                dout.write(rawImag);

                reps = connection.getResponseCode();
     //          System.out.println(reps);
                dout.close();
                if (connection != null) {
                    connection.close();
                }

                if (reps != 200) {
                    System.gc();
                    return true;
                }

            } catch (IOException e) {
                dout = null;
                connection = null;

                System.gc();
                //  System.out.println(reps);
                return true;
            //  System.out.println("***********" + e.getMessage());
            }
            System.gc();
            return false;
        }
///----------------------------------------------------------------------------------------
        public synchronized void run() {
            switch (starthttp) {
                case 0: {
                    int ret = sendLastImage(treadimag);
                    if (ret == 1) {
                        MessageBox mess = new MessageBox("Ошибка", "    Отправка данных не удалась \n  проверь настройки GPRS \n  или выбери меньшее разрешение", AlertType.ERROR);
                        rtime.addScreen();
                    }
                    break;
                }
                case 1: {
                    sendStart();
                    break;
                }
                case 2: {
                    sendStop();
                    break;
                }

            }
        }
    }//end tread

//************** Выгрузка в отдельном потоке  ***********************************
    public void SendImag(byte[] imag, String messag, int midlstart) {

        try {
            treadIm tt = new treadIm(imag, messag, midlstart);//создаём поток для загрузки

            tt.setPriority(Thread.MAX_PRIORITY);
            tt.start();
            Thread.yield();

        } catch (java.lang.ArithmeticException axz) {
            return;
        }
    }
}


