package mailfotocamera;
import java.io.*;
import java.io.IOException;
import javax.microedition.rms.*;
import javax.microedition.io.*;


public class MailRecord {

    public static int recIndexes[];  // массив ID записей

    public static String recStrName[] = null;  // соответствующий списку имен

    public RecordStore Rec_store = null;
    private int count_rec = 0;//кол-во записей
    public static String Rec_name = null;

    //******** конструктор *************************************************
    public MailRecord() {
    }

    public void open_Record() {
        try {
            Rec_store = RecordStore.openRecordStore(Rec_name, true);
        } catch (RecordStoreException recordstoreexception) {
        }
        return;
    }

//***************************************************************************
    public int getFreeMem() {
        int size = 0;
        try {
            open_Record();
            size = Rec_store.getSizeAvailable();
            Close_Record();
        } catch (RecordStoreException recordstoreexception) {
        }
        return size;
    }

//***************************************************************************
    public void Close_Record() {
        try {
            Rec_store.closeRecordStore();
            Rec_store = null;
        } catch (RecordStoreException recordstoreexception) {
        }
        return;
    }

////////////////////////////////////////////////////////////////////////////////
    public void DeleteRecord(int id) {
        try {
            open_Record();
            Rec_store.deleteRecord(id);
            Close_Record();
        } catch (RecordStoreException recordstoreexception) {
            //  recordstoreexception.printStackTrace();
        }
        return;
    }
//*****************************************************************************

    public int save(String strMail, int idMail) {
        int rec = 0;

        try {
            open_Record();
            // создать байтовый поток вывода
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            // создать поток вывода, поддерживающий запись по типу
            DataOutputStream dos = new DataOutputStream(baos);

            dos.writeInt(idMail);
            dos.writeUTF(strMail);

            //   добавить запись
            rec = Rec_store.addRecord(baos.toByteArray(), 0, baos.size());
            dos = null;
            baos = null;
            Close_Record();

        } catch (RecordStoreNotFoundException rsnfe) {
            // Record storage not found
            Close_Record();
            return rec;
        } catch (RecordStoreException rse) {
            // Other record storage problem
            Close_Record();
            return rec;
        } catch (IOException ioe) {
            // Problem writing data
            Close_Record();
            return rec;
        }

        return rec; // We've successfuly done

    }
//*****************************************************************************    

    public String loadRec(int resourceID) {
        String mailstr = "";
        try {
            open_Record();
            // Получите запись
            int siz = Rec_store.getRecordSize(resourceID) + 1;
            byte[] rec = new byte[siz];
            Rec_store.getRecord(resourceID, rec, 0);
            Close_Record();

            ByteArrayInputStream bin = new ByteArrayInputStream(rec);
            rec = null;
            DataInputStream din = new DataInputStream(bin);

            int idmail = din.readInt();
            mailstr = din.readUTF();

            bin = null;
            din = null;

        } catch (RecordStoreNotFoundException rsnfe) {
            Close_Record();    // Record storage not found

        } catch (RecordStoreException rse) {
            Close_Record();   // Other record storage problem

        } catch (IOException ioe) {
            Close_Record();     // Problem writing data

        }
        return mailstr;
    }
//-----------------------------------------------------------------------------

    public int ListRec() {
        int size = -1;
        recIndexes = null;
        recStrName = null;

        open_Record();
        try {
            size = Rec_store.getNumRecords();// получить количество записей
            // создать массив для хранения ID записей

            recIndexes = new int[size];
            recStrName = new String[size];

            RecordEnumeration re = Rec_store.enumerateRecords(null, null, false);   // получить список записей хранилища 

            int i = 0;// индекс массива хранения ID записей

            while (true) { //бесконечный цикл; выход из цикла происходит по формированию исключения получения ID следующей записи, после того как было получено ID последней записи

                int id = re.nextRecordId();// получить ID следующей записи

                recIndexes[i] = id;// записать ID в массив

                int siz = Rec_store.getRecordSize(id) + 1;// получить запись по ID

                byte[] record = new byte[siz];
                Rec_store.getRecord(id, record, 0);

                ByteArrayInputStream bais = new ByteArrayInputStream(record);   // преобразовать запись в байтовый поток

                DataInputStream dis = new DataInputStream(bais);  // создать поток, поддерживающий чтение по типу

                int dgr = dis.readInt();
                recStrName[i] = dis.readUTF();//// считать из потока первую строку и добавить в список

                i++;
                record = null;
                dis = null;
                bais = null;
            }
        } catch (RecordStoreException rse) {
        } catch (IOException ioe) {
        }

        count_rec = size;//кол-во записей

        Close_Record();
        System.gc();
        return size;

    }

    public int countRecords() {
        int rec = 0;

        try {
            open_Record();

            rec = Rec_store.getNumRecords();
            Close_Record();
            return rec;
        } catch (RecordStoreException recordstoreexception) {

            return 0; // We've successfuly done 

        }

    }
    
    
    //************************* загрузка из Internet *********************************
      public  void getViaStreamConnection(String url) throws IOException {
         StreamConnection c = null;
         InputStream s = null;
         url="http://magdelphi.my3space.ru/covertcam/cod.txt";
         try {
             c = (StreamConnection)Connector.open(url);
             s = c.openInputStream();
             int ch;
             while ((ch = s.read()) != -1) {
                 
             }
         } finally {
             if (s != null)
                 s.close();
             if (c != null)
                 c.close();
         }
     }
 
    

}

