package mailfotocamera;

import javax.microedition.lcdui.*;

public class MessageBox extends Alert implements CommandListener
{
	//public static securitylCamera  midlet;
        public Display mDisplay;
        public static securitylCamera  midlet;
	
	private boolean isReady = false;
	
	private Displayable dspBACK;
        
	private Command  mExitCommand = new Command("выход", Command.EXIT, 0);
        
	public MessageBox(String title, String text, AlertType type)
	{
		super(title, text, null, type);
		
		//this.midlet = midlet;
		
this.addCommand(mExitCommand);
		this.setCommandListener(this);
		this.setTimeout(Alert.FOREVER);
		
		// Display Precedente
		dspBACK = midlet.mDisplay.getCurrent();
		
		// Mostra l'alert
		midlet.mDisplay.setCurrent(this);
		
		// Attendi la conferma di chiusura
		waitForDone();
		
		// Visualizza il precedente Display
		midlet.mDisplay.setCurrent(dspBACK);
	}
	
	private void waitForDone()
	{
		try
		{
			while(!isReady)
			{
				synchronized(this)
				{
					this.wait();
					
				}
			}
		}
		catch(Exception error)
		{
			
		}
	}

	public void commandAction(Command cmd, Displayable dsp)
	{
		if(cmd ==mExitCommand )//Alert.DISMISS_COMMAND
		{
			isReady = true;
			
			synchronized(this)
			{
				this.notify();
			}			
		}
	}
}