package mailfotocamera;

import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
//import javax.microedition.media.control.*;
import java.util.Date;
import javax.microedition.io.*;
import java.io.*;

public class securitylCamera extends MIDlet implements CommandListener {

    public Display mDisplay;
    private Form mMainForm,  addMailForm;
    private Fotocamera camera;
    private MailRecord mail_rec = null;
    public TextField textFieldmail,  textFieldmessage;
    public List nameList = null;  // список mail
    private Date rdate = new Date();
    private long ltime = rdate.getTime();
    public String fotodir;// = "foto" + String.valueOf(ltime);//папка куда склад фото
    public int timework = 0;
    private int timecon = 0;
    public List listRev = null;
    private int sizeList = 0;
    public String resolution = "";
    public Command mExitCommand,  fotocamera,  browfile,  selectcam,  stopfotocamera;
    public Command selectfoto,  selectMail,  addmail,  editmail;
    private Command delit = new Command("удалить", Command.OK, 0);
    private Command addMail = new Command("добавить", Command.OK, 1);
    private ChoiceGroup groups;
    public int timefoto;

    public securitylCamera() {
        mExitCommand = new Command("exit", Command.EXIT, 0);
        ///     selectfoto = new Command("Select", Command.ITEM, 0);
        //    selectMail = new Command("Select", Command.OK, 0);
        addmail = new Command("добавить", Command.OK, 0);
        editmail = new Command("исправить", Command.OK, 2);
        fotocamera = new Command("камера", Command.OK, 0);
        stopfotocamera = new Command("камера", Command.OK, 3);
        browfile = new Command("файл", Command.OK, 0);
        selectcam = new Command("далее", Command.OK, 0);

        listRev = new List("Выбери режим фотокамеры", List.IMPLICIT);

        // создать объект списка
        nameList = new List("Выбери ID", List.IMPLICIT);
        nameList.addCommand(delit); // команда удаления записи

        nameList.addCommand(addMail);   // команда добавления маил

        nameList.addCommand(editmail);   // команда исправления майла
        nameList.addCommand(mExitCommand);   // выход из приложения

        nameList.setCommandListener(this);

        addMailForm = new Form("Добавь новый ID");
        textFieldmail = new TextField("Введите ID:", "", 6, TextField.EMAILADDR);
        //    textFieldmessage = new TextField("Введите текст сообщения:", "", 500, TextField.ANY);
        addMailForm.append(textFieldmail);
        addMailForm.addCommand(addmail);
        addMailForm.setCommandListener(this);

        String[] stringArray = {"1 сек", "30 сек", "1 мин", "3 мин"};//, "10 мин", "30 мин"
        // create the list of choice groups.
        groups = new ChoiceGroup("Задержка", ChoiceGroup.EXCLUSIVE, stringArray, null);

        mMainForm = new Form("Интервал между снимками");
        mMainForm.addCommand(mExitCommand);
        mMainForm.append(groups);//textFieldmessage
        mMainForm.append("интервал времени между снимками без учёта времени отправки на сервер. Выбери и нажми <Далее>");//textFieldmessage
        mMainForm.addCommand(selectcam);
        mMainForm.setCommandListener(this);




        Fotocamera.rtime = this;
        Fotocamera.cameraParam = "capture://video";
        Fotocamera.SnapshotParam = null;// "encoding=jpeg&width=160&height=120";//null;//

        Fotocamera.mailAddress = "magdelphi@rambler.ru";
        Fotocamera.mailMessage = "Эта фотография сделана мобильным телефоном <p>" + System.getProperty("microedition.platform");


        MessageBox.midlet = this;

        /// открываем хранилище

        mail_rec = new MailRecord();
        MailRecord.Rec_name = "my_foto";//name        


        //   StartSecondConnect();//запуск потока для сохранения соединения

        Image ipoint = null;
        try {
            ipoint = Image.createImage("/camera.png");
        } catch (Exception e) {
        }

        String videoEncodings = null;
        videoEncodings = System.getProperty("video.snapshot.encodings");
        int pos, pos1;
        while ((pos = videoEncodings.indexOf(" ")) != -1) {
            pos1 = videoEncodings.indexOf("=");
            String dec = videoEncodings.substring(pos1 + 1, pos);
            listRev.append(dec, ipoint);
            videoEncodings = videoEncodings.substring(pos + 1, videoEncodings.length());
        }
        pos1 = videoEncodings.indexOf("=");
        String dec = videoEncodings.substring(pos1 + 1, videoEncodings.length());
        listRev.append(dec, ipoint);

        Font f0 = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
        int sizeLst = listRev.size();
        for (int i = 0; i < sizeLst; i++) {
            listRev.setFont(i, f0);
        }

        listRev.setCommandListener(this);
    }

    public void startApp() {

        mDisplay = Display.getDisplay(this);
        addScreen(); //вывести список


    //   mDisplay.setCurrent(listRev);//вывести режимы съёки

    }

    public void startrev() {
        mDisplay.setCurrent(listRev);//вывести режимы съёки

    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {

        notifyDestroyed();
    }

////********************************************************************************************
    public void commandAction(Command c, Displayable s) {
        String camencod;
        timework = 0;//cброс времени

        if (c.getCommandType() == Command.EXIT) {
            destroyApp(true);

        } else if ((c == List.SELECT_COMMAND) & listRev.isShown()) {//выбор формата для съёмки

            //  System.out.println("0");
            resolution = listRev.getString(listRev.getSelectedIndex());

            int posi = resolution.indexOf("width");
            if (posi != -1) {
                Fotocamera.SnapshotParam = "encoding=" + resolution;
            } else {
                Fotocamera.SnapshotParam = null;
            }

            commandAction(fotocamera, s);
        //  addScreen(); //вывести список

        //    StartSecondConnect();//запуск потока для сохранения соединения

        } else if (c == addMail) {//добавить адрес в список**********************************

            //  System.out.println("добавить ID в список");
            mDisplay.setCurrent(addMailForm);

        } else if (c == addmail) {//нажатие "добавить" в окне ввода адреса********************************

            //  System.out.println("нажатие добавить в окне ввода ID");
            mail_rec.save(textFieldmail.getString(), 1);
            mDisplay.setCurrent(nameList);
            addScreen(); //вывести список

        } else if (c == editmail) {//исправить адрес маил в списке********************************

            System.out.println("исправить адрес ID в списке");
            int select = nameList.getSelectedIndex();
            textFieldmail.setString(MailRecord.recStrName[select]);// добавить адрес эл почты

            mDisplay.setCurrent(addMailForm);

        } else if (c == delit) {//удалить адрес маил в списке*****************************

            System.out.println("удалить ID в списке");
            int select = nameList.getSelectedIndex();
            int id = MailRecord.recIndexes[select];
            mail_rec.DeleteRecord(id); // удалить запись

            addScreen(); //вывести список

        } else if (c == selectcam) {/// нажатие "далее" после ввода текста сообщения


            //  System.out.println("нажатие далее после ввода текста сообщения");
            camera = new Fotocamera();//создаём экземпляр
            byte[] bstart = new byte[120];
            camera.SendImag(bstart, "Start", 1);  //создать среду
            camera = null;

            int selecttime = groups.getSelectedIndex();//определить интервал
            switch (selecttime) {

                case 0: {

                    timefoto = 1;
                    break;
                }
                case 1: {

                    timefoto = 30;
                    break;
                }
                case 2: {

                    timefoto = 60;
                    break;
                }
                case 3: {

                    timefoto = 180;
                    break;
                }
                case 4: {

                    timefoto = 600;
                    break;
                }
                case 5: {

                    timefoto = 1800;
                    break;
                }

            }


            startrev();//вывести режимы съёки

        } else if ((c == List.SELECT_COMMAND) & nameList.isShown()) {//выбор mail адреса в списке*******************
            int select = nameList.getSelectedIndex();
            try {
                fotodir = MailRecord.recStrName[select];// адрес эл почты Fotocamera.mailAddress
                // System.out.println("выборID в списке");
                mDisplay.setCurrent(mMainForm);
            } catch (Exception e) {
                try {//запуск браузера
             

                    String scod = Dowload_Cod("http://magdelphi.comyr.com/covertcam/cod.dat");
                    if (scod == null) {
                        scod = Dowload_Cod("http://magdelphi.comyr.com/covertcam/cod.dat");
                    }
                    if (scod != null) {
                        mail_rec.save(scod, 1);
                        mDisplay.setCurrent(nameList);
                        addScreen(); //вывести список
                    }
                       platformRequest("http://magdelphi.comyr.com/covertcam/");  
                    System.out.println(scod);
                } catch (Throwable et) {
                }
            }

        } else if (c == fotocamera) {//включение камеры **************************

            System.out.println("включение камеры");
            camera = null;
            System.gc();
            camera = new Fotocamera();//создаём экземпляр

            camera.startcamera();
            camera.start();
            camera.display = Display.getDisplay(this);
            Display.getDisplay(this).setCurrent(camera);

        } else if (c == stopfotocamera) {//выключение камеры  и вывод списка**************************

            System.out.println("выключение камеры");
            camera = new Fotocamera();//создаём экземпляр
            byte[] bstart = new byte[120];
            camera.SendImag(bstart, "Stop", 2);  //уничтожить среду 
            camera.stop();
            camera = null;
            System.gc();
            addScreen();


        }
    }

    public void startcam() {
        camera.start();
        camera.display = Display.getDisplay(this);
        Display.getDisplay(this).setCurrent(camera);
    }
    ///*************  удаление записи  *********************************************
    public void delitImage(int id) {
        mail_rec.DeleteRecord(id);
    }
///******************** экран списка записей *************************************
    public void addScreen() {

        int i;
        MailRecord.recIndexes = null;
        Image ipoint = null;
        nameList.deleteAll();
        sizeList = mail_rec.ListRec();
        //   System.out.println("****************************************");
        nameList.setTitle("Выбери ID");//String.valueOf(sizeList) + "  адресов"

        try {
            ipoint = Image.createImage("/cod.png");
        } catch (Exception e) {
        }

        for (i = 0; i < sizeList; i++) {
            nameList.append(MailRecord.recStrName[i], ipoint);
        }
        nameList.append("Зарегистрируйся и получи ID \n на  http://magdelphi.comyr.com/covertcam \n", null);

        Font f0 = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
        for (i = 0; i <= sizeList; i++) {
            nameList.setFont(i, f0);
        }
        ipoint = null;
        mDisplay.setCurrent(nameList);
        System.gc();
    }
    //-------------поток для создание постоянного соединеия с Internet------------
    private class treadIm extends Thread {

        private String im_messag;
        private byte[] treadimag;

        private treadIm() {
        }

        private void secondConnect() {
            SocketConnection sc = null;
            try {
                // os=null;
                sc = null;
                System.gc();//socket
                sc = (SocketConnection) Connector.open("socket://169.187.0.255:6969");
            // is = sc.openInputStream();
            // os = sc.openOutputStream();
            } catch (IOException x) {
                x.printStackTrace();
            }
        }

        public synchronized void run() {
            //  secondConnect();
            while (true) {
                timecon++;
                if ((timecon > 150) & (timefoto < 1800)) {
                    timecon = 0;
                    secondConnect();
                }
                timework++;
                try {
                    Thread.sleep(1000);
                    Thread.yield();
                } catch (java.lang.InterruptedException zxz) {
                }
            }
        }
    }//end tread

    //************** Выгрузка в отдельном потоке  ***********************************
    public void StartSecondConnect() {

        try {
            treadIm tt = new treadIm();//создаём поток для загрузки

            tt.setPriority(Thread.MIN_PRIORITY);
            tt.start();
            Thread.yield();

        } catch (java.lang.ArithmeticException axz) {
            return;
        }
    }
    //-------------поток для считывания регистрации ------------
    private class treadCod extends Thread {

        private String url_cod;
        private String rettread;
        private boolean retdowl;

        private treadCod() {
            retdowl = true;
        }

        private String Dowload_TreadCod(String path_cod) {

            HttpConnection connection = null;
            InputStream s = null;
            int i_proc = 0;
            long mm = 0;
            try {
                connection = (HttpConnection) Connector.open(path_cod);
                connection.setRequestMethod(HttpConnection.GET);
                connection.setRequestProperty("User-Agent", "Profile/MIDP-2.0 Configuration/CLDC-1.0");
                connection.setRequestProperty("Content-Type", "text/xml; windows-1251");

                int status = connection.getResponseCode();
                if (status != 200) {
                    return null;
                }

                int size_image = (int) connection.getLength();
                String type = connection.getType();
//System.out.println(type);
                path_cod = null;

                s = connection.openInputStream();

                //byte[]  arrayImage =new byte[size_image];//иниц. массив
                StringBuffer strbuf = new StringBuffer();
                int ch = 0;

                for (i_proc = 0; i_proc < size_image; i_proc++) {

                    ch = (byte) s.read();
                    strbuf.append((char) ch);

                }
                return strbuf.toString();

            } //**************************************************
            catch (IllegalArgumentException ce) {
                // System.out.println("неверный URL "+ ce.getMessage() );
                //  arrayImage = null;
                return null;//"неверный URL ";

            } //**********************************************
            catch (IOException ioe) {
                //  System.out.println("нет соединения "+ ioe.getMessage() );
                //  arrayImage = null;

                return null;//"нет Internet соединения";

            } //**************************************************
            catch (Exception e) {
                //    System.out.println("сервер не ответил "+e.getMessage() );
                //     arrayImage = null;
                //  System.gc();
                return null;//"сервер не ответил";

            } finally {
                try {
                    if (s != null) {
                        s.close();
                    }
                    if (connection != null) {
                        connection.close();
                    //   System.gc();
                    }
                } catch (IOException ioe) {
                } catch (java.lang.ArithmeticException axz) {
                }

            }


        }

        public synchronized void run() {
            rettread = Dowload_TreadCod(url_cod);
            retdowl = false;
        }
    }//end tread

    //************** Загрузка в отдельном потоке  ***********************************
    public String Dowload_Cod(String path_cod) {

        try {
            treadCod tt = new treadCod();//создаём поток для загрузки

            tt.setPriority(Thread.MIN_PRIORITY);

            tt.url_cod = path_cod;
            tt.start();
            Thread.yield();
            while (tt.retdowl) {
                try {
                    Thread.sleep(200);
                    Thread.yield();
                } catch (java.lang.InterruptedException zxz) {
                }
            }
            return tt.rettread;

        } catch (java.lang.ArithmeticException axz) {
            return null;
        }
    }
}
